Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 3346)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 3347)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! - offline nesting separated from large-scale forcing module
+! - changes for synthetic turbulence generator
+! 
+! 3343 2018-10-15 10:38:52Z suehring
 ! - Formatting, clean-up, comments (kanani)
 ! - Added CALL to chem_emissions_setup (Russo)
@@ -459,12 +463,15 @@
 
     USE lsf_nudging_mod,                                                       &
-        ONLY:  calc_tnudge, ls_forcing_surf, ls_forcing_vert, nudge_ref,       &
-               lsf_nesting_offline, lsf_nesting_offline_mass_conservation
+        ONLY:  calc_tnudge, ls_forcing_surf, ls_forcing_vert, nudge_ref
 
     USE multi_agent_system_mod,                                                &
         ONLY:  agents_active, multi_agent_system
-
+        
+    USE nesting_offl_mod,                                                      &
+        ONLY:  nesting_offl_bc, nesting_offl_mass_conservation
+        
     USE netcdf_data_input_mod,                                                 &
-        ONLY:  chem_emis, chem_emis_att, nest_offl, netcdf_data_input_lsf
+        ONLY:  chem_emis, chem_emis_att, nest_offl,                            &
+               netcdf_data_input_offline_nesting
 
     USE ocean_mod,                                                             &
@@ -515,5 +522,7 @@
 
     USE synthetic_turbulence_generator_mod,                                    &
-        ONLY:  stg_main, use_syn_turb_gen
+        ONLY:  dt_stg_call, dt_stg_adjust, parametrize_inflow_turbulence,      &
+               stg_adjust, stg_main, time_stg_adjust, time_stg_call,           &
+               use_syn_turb_gen
 
     USE user_actions_mod,                                                      &
@@ -638,5 +647,5 @@
        IF ( nesting_offline )  THEN
           IF ( nest_offl%time(nest_offl%tind_p) <= time_since_reference_point )&
-             CALL netcdf_data_input_lsf
+             CALL netcdf_data_input_offline_nesting
        ENDIF
 
@@ -918,8 +927,4 @@
 !--       Impose a turbulent inflow using the recycling method
           IF ( turbulent_inflow )  CALL  inflow_turbulence
-
-!
-!--       Impose a turbulent inflow using synthetic generated turbulence
-          IF ( use_syn_turb_gen )  CALL  stg_main
 
 !
@@ -960,11 +965,19 @@
 !--       boundaries. 
           IF ( nesting_offline  .AND.  intermediate_timestep_count ==          &
-                                       intermediate_timestep_count_max  )  THEN
-             CALL lsf_nesting_offline
-!
-!--          Moreover, ensure mass conservation
-             CALL lsf_nesting_offline_mass_conservation
-          ENDIF
-
+                                       intermediate_timestep_count_max  )      &
+             CALL nesting_offl_bc
+!
+!--       Impose a turbulent inflow using synthetic generated turbulence, 
+!--       only once per time step.
+          IF ( use_syn_turb_gen  .AND.  time_stg_call >= dt_stg_call  .AND.    &
+             intermediate_timestep_count == intermediate_timestep_count_max )  THEN! &
+             CALL stg_main
+          ENDIF
+!
+!--       Ensure mass conservation. This need to be done after imposing
+!--       synthetic turbulence and top boundary condition for pressure is set to
+!--       Neumann conditions. 
+!--       Is this also required in case of Dirichlet?
+          IF ( nesting_offline )  CALL nesting_offl_mass_conservation
 !
 !--       Reduce the velocity divergence via the equation for perturbation
@@ -1213,4 +1226,15 @@
        time_dopr_listing          = time_dopr_listing        + dt_3d
        time_run_control   = time_run_control + dt_3d
+!
+!--    In case of synthetic turbulence generation and parametrized turbulence
+!--    information, update the time counter and if required, adjust the 
+!--    STG to new atmospheric conditions.
+       IF ( use_syn_turb_gen  )  THEN
+          IF ( parametrize_inflow_turbulence )  THEN
+             time_stg_adjust = time_stg_adjust + dt_3d
+             IF ( time_stg_adjust >= dt_stg_adjust )  CALL stg_adjust
+          ENDIF
+          time_stg_call = time_stg_call + dt_3d
+       ENDIF
 
 !
@@ -1472,5 +1496,6 @@
 
     ENDDO   ! time loop
-
+    
+!
 !-- Vertical nesting: Deallocate variables initialized for vertical nesting    
     IF ( vnest_init )  CALL vnest_deallocate
Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3346)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3347)
@@ -28,4 +28,8 @@
 ! -----------------
 ! $Id$
+! Enable USM initialization with default building parameters in case no static
+! input file exist. 
+! 
+! 3343 2018-10-15 10:38:52Z suehring
 ! Add output variables usm_rad_pc_inlw, usm_rad_pc_insw*
 ! 
@@ -6902,4 +6906,6 @@
         INTEGER(iwp)                                          :: wtc
         REAL(wp), DIMENSION(n_surface_params)                 :: wtp
+        
+        LOGICAL                                               :: ascii_file = .FALSE.
     
         INTEGER(iwp), DIMENSION(0:17, nysg:nyng, nxlg:nxrg)   :: usm_par
@@ -6922,4 +6928,11 @@
         IF ( building_type_f%from_file  .OR.  building_pars_f%from_file )      &
            RETURN
+!
+!--     Check if ASCII input file exists. If not, return and initialize USM
+!--     with default settings.
+        INQUIRE( FILE = 'SURFACE_PARAMETERS' // coupling_char,                 &
+                 EXIST = ascii_file )
+                 
+        IF ( .NOT. ascii_file )  RETURN
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
